<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.inc.php,v 1.1.1.1 2006/02/20 21:52:23 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"comments", "gallery", "format.lib.php"
	);

	Extract (
		URLGetArgs("null/action=alpha?id=int&page=page")
	);

	function processGalleryRow(&$row) {

		saneHTML($row, "description");
		Format::Style($row["description"], $row["authorid"]);

		list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnailsize"]);

		$row["ACTIONS"] = new tplButtonBox();
			$row["ACTIONS"]->add(mklink("index.php/module=gallery/action=show_items/title=".title_encode($row["title"])."?id={$row["id"]}", _l("L_VIEW"), "submit.png"));
		$row["ACTIONS"] = $row["ACTIONS"]->make();
	}

	switch ($action) {
		case "view":

			if ($id) {

				$tpl = new contentBlock();
				$tpl->insert("BLOCK_CONTENT", "gallery/view.tpl");

				$db->query("SELECT id, title, description, mediaurl, mediasize, thumbnail,
				thumbnailsize, authorid, lastupdated, allowcomments
				FROM ".db_table("gallery_item")." WHERE id = '{$id}'", __FILE__, __LINE__);

				$row = $db->fetch_row();

				saneHTML($row, "description");
				Format::Style($row["description"], $row["authorid"]);

				/* media size */
				$mediasize = explode("x", $row["mediasize"]);
				if (count($mediasize) == 2) {
					$larger = conf::getKey("gallery", "item.larger_size", 342, "i");

					// if media size exceeds maximum, using simple scaling
					$mediasize[intval($mediasize[0]>$larger)] = $mediasize[($mediasize[0]>$larger)]*$larger/$mediasize[intval(!($mediasize[0]>$larger))];
					$mediasize[intval(!($mediasize[0]>$larger))] = $larger;

					list($row["MEDIA.WIDTH"], $row["MEDIA.HEIGHT"]) = $mediasize;
				}

				// thumbnail
				list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnailsize"]);

				$row["mediaurl"] = rel_link($row["mediaurl"]);

				// displaying media in different presentations depending on media type
				$row["MEDIATYPE"] = gallery::guessMediaType($row["mediaurl"]);

				$tpl->set_arr($row);

				$tpl->set_arr(
					Array (
						"BLOCK_TITLE"	=> $row["title"],
						"BLOCK_ICON"	=> mkIcon("gallery.png", 16),
						"PAGE"			=> $page
					)
				);

				$mcBuff = $tpl->make();

			} else {
				$mcBuff = accessDenied();
			}
		break;
		case "show_items": case "items":

			if ($id) {
				$tpl = new contentBlock();

				$tpl->insert("BLOCK_CONTENT", "gallery/show_items.tpl");

				$db->query("SELECT
				id, title, description, thumbnail, thumbnailsize, auth_access
				FROM ".db_table("gallery")." WHERE id = '{$id}'",
				__FILE__, __LINE__);

				$row = $db->fetch_row();

				if ($db->num_rows() && gauth($row["auth_access"])) {

					// subgalleries
					$gallery_lock = "(id = '".implode("' OR id ='", gallery::getAllowedGalleries($row["id"]))."')";

					$db->query ("SELECT
					id, title, description, thumbnail, thumbnailsize, authorid, lastupdated
					FROM ".db_table("gallery")." WHERE {$gallery_lock}",
					__FILE__, __LINE__);

					while ($row2 = $db->fetch_row()) {

						processGalleryRow($row2);

						$tpl->set_arr($row2, "GALLERY");
						$tpl->savebuff("GALLERY");
					}

					// items for this gallery
					$pager = $db->pager (
						"SELECT id FROM ".db_table("gallery_item")."
						WHERE gallerylink = '{$row["id"]}'",
						"index.php/module=gallery/action=show_items/title=".title_encode($row["title"])."?id={$row["id"]}&page=%p",
						$page, conf::getkey("gallery", "items_per_page")
					);

					$db->query("SELECT id, title, description, thumbnail, thumbnailsize,
					lastupdated, authorid, allowcomments
					FROM ".db_Table("gallery_item")."
					WHERE gallerylink = '{$row["id"]}' {$pager["sql"]}", __FILE__, __LINE__);

					while ($row2 = $db->fetch_row()) {
						saneHTML($row2, "description");
						Format::Style($row2["description"], $row2["authorid"]);

						list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnailsize"]);

						$tpl->set_arr($row2, "ITEM");
						$tpl->savebuff("ITEM");
					}

					$tpl->set_arr ($row);
					$tpl->set_arr (
						Array (
							"BLOCK_TITLE"		=> _l("L_GALLERY"),
							"BLOCK_ICON"		=> mkIcon("gallery.png", 16),
							"BLOCK_SUBTITLE"	=> $row["title"],
							"PAGER"				=> $pager["html"]
						)
					);

					$mcBuff = $tpl->make();
				} else {
					$mcBuff = accessDenied();
				}
			}
		break;
		default: {

			$gallery_lock = "(id = '".implode("' OR id ='", gallery::getAllowedGalleries())."')";

			$pager = $db->pager (
				"SELECT id FROM ".db_table("gallery")."
				WHERE {$gallery_lock}",
				"index.php/module=gallery?page=%p", $page, conf::getKey("gallery", "items_per_page")
			);

			$db->query("SELECT
			id, title, description, thumbnail, thumbnailsize, authorid, lastupdated
			FROM ".db_table("gallery")." WHERE {$gallery_lock} ORDER BY
			title ASC {$pager["sql"]}", __FILE__, __LINE__);

			if ($db->num_rows()) {

				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "gallery/index.tpl");

				while ($row = $db->fetch_row()) {

					processGalleryRow($row);

					$tpl->set_arr($row, "GALLERY");
					$tpl->savebuff("GALLERY");
				}

				$tpl->set_arr (
					Array (
						"BLOCK_TITLE"		=> _l("L_GALLERY"),
						"BLOCK_SUBTITLE"	=> _l("L_GALLERIES"),
						"BLOCK_ICON"		=> mkIcon("gallery.png", 16),
						"PAGER"				=> $pager["html"]
					)
				);

				$mcBuff = $tpl->make();
			}
		}
	}

?>