<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: module.inc.php,v 1.1.1.1 2006/02/20 21:52:23 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class GekkoModule_Gallery {
		function create_menu() {
			return false;
		}
		function configure() {
			Conf::getKey("gallery", "items_per_page", 8, "i");
			Conf::getKey("gallery", "allow_user_comments", 1, "b");
			Conf::getKey("gallery", "items_per_admin_page", 24, "i");
			Conf::getKey("gallery", "thumbnail.longest_side", 140, "i");
			conf::getkey("gallery", "default_size", "512x384", "s");
		}
		function install() {

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("gallery")." (
				id SMALLINT (5) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY(ID),
				gallerylink SMALLINT (5) UNSIGNED NOT NULL default '0',
				title VARCHAR (255),
				description TEXT,
				status ENUM('0','1') NOT NULL default '1',
				thumbnail VARCHAR (255),
				thumbnailsize VARCHAR (32),
				authorid MEDIUMINT (8) UNSIGNED NOT NULL,
				creationtime INT (11) UNSIGNED NOT NULL,
				lastupdated INT (11) UNSIGNED NOT NULL,
				auth_access VARCHAR (255)
			)
			", __FILE__, __LINE__, true);

			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("gallery_item")." (
				id INT (11) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				gallerylink SMALLINT (5) UNSIGNED NOT NULL,
				title VARCHAR (255),
				description TEXT,
				thumbnail VARCHAR (255),
				thumbnailsize VARCHAR (32),
				mediaurl VARCHAR (255),
				mediasize VARCHAR (32),
				authorid MEDIUMINT (8) UNSIGNED NOT NULL,
				creationtime INT (11) UNSIGNED NOT NULL,
				lastupdated INT (11) UNSIGNED NOT NULL,
				allowcomments ENUM('0','1') NOT NULL default '1'
			)
			", __FILE__, __LINE__, true);

			modCore::registerModule($GLOBALS["cgdb"]["gallery"], "gallery", "*", $GLOBALS["cgdb"]["gallery"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("gallery"), __FILE__, __LINE__, true);
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("gallery_item"), __FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {
			if (Packages::checkVersion("0.5.9", $provided_v) < 0) {
				$GLOBALS["db"]->query("ALTER TABLE ".db_table("gallery")."
				CHANGE COLUMN status status ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);

				$GLOBALS["db"]->query("ALTER TABLE ".db_table("gallery_item")."
				CHANGE COLUMN allowcomments allowcomments ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);
			}
		}
		function ext_uninstall($module) {

		}
	}

?>